#!/usr/bin/perl

###############################
#	Ratssi 4.5			#
#	for YaBB SP 1.3		#
#	by Carsten			#
###############################

use CGI::Carp qw(fatalsToBrowser);
require "Paths.pl";
require "$vardir/Settings.pl";
require "$vardir/RatingConf.txt";
require "$sourcedir/Load.pl";
require "$sourcedir/Subs.pl";
&LoadLanguage("RateIT");
use CGI qw/:standard/;

print "Content-type: text/html\n\n";

##### Link Style Settings #####
print <<"EOT";
<style type="text/css">
<!--
.titl          { font-weight: bold; text-decoration: none; color: #000000; }
.titl:link     { font-weight: bold; text-decoration: none; color: #000000; }
.titl:visited  { font-weight: bold; text-decoration: none; color: #000000; }
.titl:hover    { font-weight: bold; text-decoration: none; color: #6394BD; font-weight: bold; text-decoration: underline; }
-->
</style>
EOT

####### Table Settings ########
$tablewidth = "300"; 			# set tablewidth
$tableborder = "1"; 			# set to 1 for tableborder or 0 for no tableborder
$tabletitlebg = "1";			# set to 1 for title background color or 0 for no title background color
$tabledescrbg = "1";			# set to 1 for description background color or 0 for no description background color
$tablebordercolor = "#62686F";	# set tableborder color
$tabletitlebgcolor = "#F2F6F9";	# set title background color
$tabledescrbgcolor = "#333333";	# set description background color

######## Font Settings ########
$titlefontsize = "1";			# set text size for title (default 2)
$textfontsize = "1";			# set text size for description (default 1)
$titlefontcolor = "#000000";		# set text color for title (default black)
$textfontcolor = "#000000";		# set text color for description (default black)
$fontface = "Arial";			# set text font (default Arial)

###############################

foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
	$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	($cookie,$value) = split(/=/);
	$yyCookies{$cookie} = $value;
}
if( $yyCookies{$cookiepassword} ) {
	$password = $yyCookies{$cookiepassword};
	$username = $yyCookies{$cookieusername} || 'Guest';
} else {
	$password = '';
	$username = 'Guest';
}

getinfo(%theinfo);

my($showtitle, $showbar, $showtext, $rate);

($showtitle, $showbar, $showtext, $rate) = split(/\|/,$theinfo{'rateid'});

	$masterseed = substr($date, length($date) - 4, length($date));
	$formsession = &encode_session($mbname, $masterseed);
	$formsession .= $masterseed;

	@rateinfo = ();
	open(RATEFILEREAD,"$RatesDir/$rate.rate");
	&lock(RATEFILEREAD);
	@rateinfo = <RATEFILEREAD>;
	$lines = @rateinfo;
	&unlock(RATEFILEREAD);
	close(RATEFILEREAD);
	chomp @rateinfo;
	($thisname, $dummy) = split(/\|/,$rateinfo[1]);
	$thisuser = $username;
	if($thisuser eq "Guest") { $thisuser = $user_ip }
	$totalrate = 0;
	$raters = $lines - 5;
	if($raters > 0) {
		for($i=5; $i < $lines; $i++) {
			($thisrater, $thisrate) = split(/\|/,$rateinfo[$i]);
			if($thisuser eq $thisrater) { 
				$intrate = int($thisrate);
				$check[$intrate] = "selected";
			}
			$totalrate = $totalrate + $thisrate;
		}
		$therate = sprintf ("%.2f", ($totalrate/$raters));
	}
	else { $therate = "0.00" }

	($rating, $clicks) = split(/\|/,$rateinfo[3]);
	$link = $rateinfo[4];
	$barrate = $rating * 10;
	$ratebar = "";
	$ratebar1 = "";
	$ratebar2 = "";
	$barchart = int($barrate);
	$barchart1 = 100 - $barchart;
	if ($barchart < 1) {$ratebar = "$ratebar";}
	else {
		$ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" />~;
	}
	if ($barchart > 99) {$ratebar1 = "$ratebar1";}
	else {
		$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" />~;
	}
	$ratebar2 = qq~$ratebar$ratebar1~;

	$descrip = $rateinfo[2];
	$descrip =~ s~\&\&~<br>~g;
	$message = $descrip;
	&wrap;
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;

	$descrip = $message;

	$ssispan = 1;

	if($tableborder) {
print <<"EOT";
		<table width="$tablewidth" align="center" border="0" cellpadding="0" cellspacing="0" bgcolor="$tablebordercolor">
EOT
		}
		else {
print <<"EOT";
		<table width="$tablewidth" align="center" border="0" cellpadding="0" cellspacing="0">
EOT
		}
print <<"EOT";
<tr>
<td width="100%">

<table width="100%" border="0" cellpadding="0" cellspacing="1">
<tr>
EOT
if($showtitle) {
	$ssispan++;
print <<"EOT";
	<td width="40%" align="left">
EOT
		if($tabletitlebg) {
print <<"EOT";
			<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="left" bgcolor="$tabletitlebgcolor">
EOT
		}
		else {
print <<"EOT";
			<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="left">
EOT
		}
print <<"EOT";
		<tr>
EOT
		if($link eq "") {
print <<"EOT";
			<td align="left" height="100%">
			<font face="$fontface" size="$titlefontsize" color="$titlefontcolor"><nobr><b>$thisname</b></nobr></font>
			</td>
EOT
	}
	else {
print <<"EOT";
			<td align="left" height="100%">
			<font face="$fontface" size="$titlefontsize" color="$titlefontcolor"><nobr><b><a href="$boardurl/YaBB.cgi?action=rateclicks;rateid=$rate" name="$rate" class="titl">$thisname</a></b></nobr></font>
			</td>
			<td align="right" height="100%">
			<font face="$fontface" color="$titlefontcolor" size="1"><nobr><i> $ratetxt{'17'}: $clicks </i></nobr></font>
			</td>
EOT
	}
print <<"EOT";
		</tr>
		</table>
	</td>
EOT
}
print <<"EOT";
	<td align="right">
EOT
		if($tabletitlebg) {
print <<"EOT";
			<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="right" bgcolor="$tabletitlebgcolor">
EOT
		} else {
print <<"EOT";
			<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="right">
EOT
		}
print <<"EOT";
		<tr>
		<td align="right" height="100%">
			<font face="$fontface" size="$titlefontsize" color="$titlefontcolor"><nobr>&nbsp; $ratetxt{'03'}: </nobr></font>
		</td>
		<form method="post" action="$boardurl/YaBB.cgi?action=ratesett2" name="$rate">
		<input type="hidden" name="filename" value="$rate" />
		<input type="hidden" name="username" value="$username" />
		<input type="hidden" name="ratetype" value="rateex" />
		<input type="hidden" name="formsession" value="$formsession" />
		<td align="left" height="100%">
			<select name="rating" onChange="submit(); return true">
				<option value="0" $check[0]>---</option>
				<option value="10" $check[10]>10 $ratetxt{'48'}</option>
				<option value="9" $check[9]>9</option>
				<option value="8" $check[8]>8</option>
				<option value="7" $check[7]>7</option>
				<option value="6" $check[6]>6</option>
				<option value="5" $check[5]>5</option>
				<option value="4" $check[4]>4</option>
				<option value="3" $check[3]>3</option>
				<option value="2" $check[2]>2</option>
				<option value="1" $check[1]>1</option>
			</select>
		</td>
		</form>
		</tr>
		</table>
	</td>
EOT
if($showbar) {
	$ssispan++;
print <<"EOT";
	<td width="40%" align="right">
EOT
		if($tabletitlebg) {
print <<"EOT";
		<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="right" bgcolor="$tabletitlebgcolor">
EOT
		}
		else {
print <<"EOT";
		<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="right">
EOT
		}
print <<"EOT";
		<tr>
			<td align="right">
				<font face="$fontface" size="$titlefontsize" color="$titlefontcolor">$therate</font>
			</td>
			<td width="110" align="left">
				<nobr><a href="$boardurl/YaBB.cgi?action=rateoverview;rateid=$rate">$ratebar2</a></nobr>
			</td>
			<td width="50" align="left">
				<font face="$fontface" size="1" color="$titlefontcolor"><nobr><i>&nbsp;$ratetxt{'05'}: $raters</i></nobr></font>
			</td>
		</tr>
		</table>
	</td>
EOT
}
print <<"EOT";
</tr>
EOT
if($showtext) {
print <<"EOT";
<tr>
EOT
	if($showtitle || $showbar) {
print <<"EOT";
	<td width="100%" align="left" valign="top" colspan="$ssispan">
EOT
}
else {
print <<"EOT";
	<td width="100%" align="left" valign="top">
EOT
}
		if($tabledescrbg) {
print <<"EOT";
			<table height="100%" width="100%" border="0" border="0" cellspacing="0" cellpadding="4" align="left" bgcolor="$tabledescrbgcolor">
EOT
		}
		else {
print <<"EOT";
			<table height="100%" width="100%" border="0" border="0" cellspacing="0" cellpadding="4" align="left">
EOT
		}
print <<"EOT";
		<tr>
			<td height="100%" width="100%" align="left" valign="top">
			<font face="$fontface" size="$textfontsize" color="$textfontcolor">$descrip</font>
			</td>
		</tr>
		</table>
	</td>
</tr>
EOT
}
print <<"EOT";
</table>

</td>
</tr>
</table>

EOT

sub getinfo {

my ($tmpst);

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	$tmpst = $ENV{'QUERY_STRING'};
}
else {
	read(STDIN, $tmpst, $ENV{'CONTENT_LENGTH'});
}

foreach (split(/&/, $tmpst)) {
	my($key, $value) = split(/=/, $_);
	$value =~ tr/+/ /;
	$value =~ s/%(..)/pack('c', hex($1))/eg;
	$theinfo{$key} = $value;
}

}

sub lock {
	my $lock_file = $_[0];
	my $flag = 1;
	my $count = 0;
	if($use_flock==1) {
		flock($lock_file, $LOCK_EX);
	} elsif ($use_flock==2) {

		while($flag and $count < 15) {
			$flag = check_flock($lock_file);
			$count++;
		}

		unlink($lock_file) if ($count == 15);
		open(LOCK_FILE, ">$lock_file");
	}
}

sub unlock {
	my $lock_file = $_[0];

	if($use_flock==1) {
		flock($lock_file, $LOCK_UN);
	} elsif ($use_flock==2) {
		close(LOCK_FILE);
		unlink($lock_file) if (-e $lock_file);
	}
}


exit;

1;