<id>
RateIT
</id>

<version>
v1.9
</version>

<mod info>
For YaBB2.1
This mod add Ratings in your forum.

Admin can:
 - Enable or Disable Rating
 - Show 'Rating List' button on YaBB menu for Guests, Member and Guests, or Disable
 - Enable comments in Rating List
 - Stars instead of bars in Rating List
 - Place Rating in Thread. Below, Above, or Disable
 - Enable Rating comments in Thread
 - Allow UBBC in comments
 - Set max. characters in comments
 - Set specific MemberGroups to add item in Ratings List
 - Allow Moderator to add Rating in Thread
 - Allow Guests to rate
 - Open rate links in new window
 - Set Rating items per page on Rating List
 
For each Board Admin can:
 - Allow Rating (enable to add Rating for Thread)
 - Auto-apply Rating (enable to auto-add Rating for all new Posts)
 - Set option for view Rating on Message Index (Enable or Disable, Show graphics only, Stars or Bars)
 - Enable show Board in Rating List
</mod info>

<author>
Original mod version Ratings SP1.3 v 4.5 by: Carsten. BIG THANKS!Change and expand futures for YaBB2 by: Boris Tjuvanov (MF-B)Big thanks for testing, ideas and... help: Jeffrey Man (Jet Li)Images by: Carsten and Jet Li
</author>

<homepage>
http://yabb.xost.ru/ and http://www.grafix-world.nl
</homepage>

<edit file>
Admin/AdminEdit.pl
</edit file>

<search for>
%gmod_access = (
</search for>

<add after>
'ratings',"$FORM{'ratings'}",
</add after>

<search for>
%gmod_access2 = (
</search for>

<add after>
ratings2 => "$FORM{'ratings'}",
rebuildrate => "$FORM{'ratings'}",
</add after>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'referer_control',"Admin.pl&Refcontrol",
</search for>

<add before>
'ratings',"RatingAdmin.pl&RatingSET",
'ratings2',"RatingAdmin.pl&RatingSET2",
'rebuildrate',"RatingAdmin.pl&RebuildRate",
'convertrate',"RatingAdmin.pl&ConvertRate",
</add before>

<edit file>
Admin/ManageBoards.pl
</edit file>

<search for>
		foreach $curmessage (@messages) {
			($id, $dummy) = split(/\|/, $curmessage);
			unlink("$datadir/$id\.txt");
			unlink("$datadir/$id\.mail");
			unlink("$datadir/$id\.ctb");
			unlink("$datadir/$id\.data");
			unlink("$datadir/$id\.poll");
			unlink("$datadir/$id\.polled");
</search for>

<add after>
			if(-e ("$RatesDir/$id.rate")) {
				fopen(FILE, "$vardir/rateitlist.txt");
				@ratelist = <FILE>;
				fclose(FILE);
				fopen(FILE, ">$vardir/rateitlist.txt", 1);
				foreach $currate (@ratelist) {
					chomp $currate;
					($thiscurrate, $dummy, $dummy, $dummy) = split(/\|/, $currate);
					if($thiscurrate ne $id) { print FILE "$currate\n"; }
				}
				fclose(FILE);
				unlink("$RatesDir/$id\.rate");
			}
</add after>

<search for>
sub AddBoards {
	my @editboards = @_;
	&is_admin_or_gmod;
	if ($INFO{"action"} eq "boardscreen") { $FORM{"amount"} = $#editboards; }
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
</search for>

<add after>
if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; }
if ($enable_ratings) {
	LoadLanguage("RateIT");
	my ($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst);
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @boardratecontrols = <RATECONTROL>;
	fclose(RATECONTROL);
	foreach my $boardrateline (@boardratecontrols) {
		$boardrateline =~ s/[\r\n]//g;
		chomp $boardrateline;
		($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst) = split(/\|/, $boardrateline);
		${$uid.$cntrateboard}{'brate_enable'} = $cntbrateenable;
		${$uid.$cntrateboard}{'apply_arate'} = $cntautoapplyrate;
		${$uid.$cntrateboard}{'view_arate'} = $cntviewrateindex;
		${$uid.$cntrateboard}{'view_ratestar'} = $cntratestar;
		${$uid.$cntrateboard}{'view_rategraph'} = $cntrategraph;
		${$uid.$cntrateboard}{'view_bratelst'} = $cntboardratelst;
	}
}
</add after>

<search for>
		$ann      = "";
		$rbin     = "";
		$zeroch   = "";
		$attch    = "";
		$showpriv = "";
		$brdpic   = "";
</search for>

<add after>
		$brateenablechecked= "";
		$aratechecked   = "";
		$viewratechecked   = "";
		$ratestarchecked   = "";
		$rategraphchecked   = "";
		$boardratelstchecked = "";
		
		if (${$uid.$editboards[$i]}{'brate_enable'} == 1)		{$brateenablechecked = qq~ checked="checked"~;}
		if (${$uid.$editboards[$i]}{'apply_arate'} == 1)			{$aratechecked = qq~ checked="checked"~;}
		if (${$uid.$editboards[$i]}{'view_arate'} == 1)			{$viewratechecked = qq~ checked="checked"~;}		
		if (${$uid.$editboards[$i]}{'view_ratestar'} == 1)		{$ratestarchecked = qq~ checked="checked"~;}
		if (${$uid.$editboards[$i]}{'view_rategraph'} == 1)	{$rategraphchecked = qq~ checked="checked"~;}
		if (${$uid.$editboards[$i]}{'view_bratelst'} == 1)		{$boardratelstchecked = qq~ checked="checked"~;}
</add after>

<search for>
    <td class="windowbg" width="25%" align="left"><b>$admin_txt{'64e'}</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="show$i" value="1"$showpriv /> $admin_txt{'64f'}</td>
</search for>

<add after>
		~;

if ($enable_ratings) {
		$yymain .= qq~
   </tr><tr>
		<td class="windowbg" width="25%" align="left"><b>$mbcrate{'10'}</b></td>
		<td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="brate_enable$i" value="1"$brateenablechecked /> $mbcrate{'11'}</td>
   </tr><tr>
		<td class="windowbg" width="25%" align="left" valign="top"><b>$mbcrate{'01'}</b></td>
		<td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="apply_arate$i" value="1"$aratechecked /> $mbcrate{'08'}</td>
   </tr><tr>
         <td class="windowbg" width="25%" align="left" valign="top"><b>$mbcrate{'03'}</b></td>
         <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="view_arate$i" value="1"$viewratechecked /> $mbcrate{'03a'}<br /><br />
         <input type="checkbox" name="view_ratestar$i" value="1"$ratestarchecked /> <font size="1">$mbcrate{'05'}</font><br />
         <input type="checkbox" name="view_rategraph$i" value="1"$rategraphchecked /> <font size="1">$mbcrate{'06'}</font></td>
   </tr><tr>
		<td class="windowbg" width="25%" align="left"><b>$mbcrate{'07'}</b></td>
		<td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="view_bratelst$i" value="1"$boardratelstchecked /> $mbcrate{'09'}</td>
		~;
}

		$yymain .= qq~
</add after>

<search for>
		push(@changes,      $id);
</search for>

<add before>
		push(@boardratecnt, "$FORM{\"cat$i\"}|$id|$FORM{\"brate_enable$i\"}|$FORM{\"apply_arate$i\"}|$FORM{\"view_arate$i\"}|$FORM{\"view_ratestar$i\"}|$FORM{\"view_rategraph$i\"}|$FORM{\"view_bratelst$i\"}\n");
</add before>

<search for>
	seek FORUMCONTROL, 0, 0;
	truncate FORUMCONTROL, 0;
	push(@boardcontrol, @oldcontrols);
	@boardcontrol = sort(@boardcontrol);
	print FORUMCONTROL @boardcontrol;
	fclose(FORUMCONTROL);
	$action_area = "manageboards";
	&AdminTemplate;
	exit;
</search for>

<replace>
	seek FORUMCONTROL, 0, 0;
	truncate FORUMCONTROL, 0;
	push(@boardcontrol, @oldcontrols);
	@boardcontrol = sort(@boardcontrol);
	print FORUMCONTROL @boardcontrol;
	fclose(FORUMCONTROL);
	
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @oldratecnt = <RATECONTROL>;
	my ($oldrboard, $oldrcontrol, $changedboard,);
	for (my $cnt = 0; $cnt <= $#oldratecnt; $cnt++) {
		($dummy, $oldrboard, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy) = split(/\|/, $oldratecnt[$cnt]);
		foreach $changedboard (@changes) {
			chomp $changedboard;
			if ($changedboard eq $oldrboard) {
				$oldratecnt[$cnt] = "";
			}
		}
	}
	seek RATECONTROL, 0, 0;
	truncate RATECONTROL, 0;
	push(@boardratecnt, @oldratecnt);
	@boardratecnt = sort(@boardratecnt);
	print RATECONTROL @boardratecnt;
	fclose(RATECONTROL);
	require "$admindir/RatingAdmin.pl";
	&RebuildRate;
	
	$action_area = "manageboards";
	&AdminTemplate;
	exit;
</replace>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
if ($action eq 'detailedversion') { return 1; }
</search for>

<add after>
LoadLanguage("RateIT");
</add after>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$Rate_IT = "RateIT_Mod|$ratetxt{'140'}|$ratetxt{'126a'}|1.9|September 04th, 2006|";
	push (@installed_mods, "$Rate_IT");
</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
'627' => "Mark as Unread",
</search for>

<add after>
'02d' => "Rating List",
'03d' => "Add Rating",
'04d' => "Remove Rating",
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	&BoardTotals("load", @loadboards);
</search for>

<add after>
if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; LoadLanguage("RateIT"); }
if ($enable_ratings) {
	my ($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst);
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @boardratecontrols = <RATECONTROL>;
	fclose(RATECONTROL);
	foreach my $boardrateline (@boardratecontrols) {
		$boardrateline =~ s/[\r\n]//g;
		chomp $boardrateline;
		($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst) = split(/\|/, $boardrateline);
		${$uid.$cntrateboard}{'brate_enable'} = $cntbrateenable;
		${$uid.$cntrateboard}{'apply_arate'} = $cntautoapplyrate;
		${$uid.$cntrateboard}{'view_arate'} = $cntviewrateindex;
		${$uid.$cntrateboard}{'view_ratestar'} = $cntratestar;
		${$uid.$cntrateboard}{'view_rategraph'} = $cntrategraph;
		${$uid.$cntrateboard}{'view_bratelst'} = $cntboardratelst;
	}
}
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
if ($action eq 'detailedversion') { return 1; }
</search for>

<add after>
if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; LoadLanguage("RateIT"); }
</add after>

<search for>
	&BoardTotals("load", $currentboard);
</search for>

<add after>
if ($enable_ratings) {
	my ($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst);
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @boardratecontrols = <RATECONTROL>;
	fclose(RATECONTROL);
	foreach my $boardrateline (@boardratecontrols) {
		$boardrateline =~ s/[\r\n]//g;
		chomp $boardrateline;
		($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst) = split(/\|/, $boardrateline);
		if ($currentboard eq $cntrateboard) {
			${$uid.$cntrateboard}{'brate_enable'} = $cntbrateenable;
			${$uid.$cntrateboard}{'apply_arate'} = $cntautoapplyrate;
			${$uid.$cntrateboard}{'view_arate'} = $cntviewrateindex;
			${$uid.$cntrateboard}{'view_ratestar'} = $cntratestar;
			${$uid.$cntrateboard}{'view_rategraph'} = $cntrategraph;
			${$uid.$cntrateboard}{'view_bratelst'} = $cntboardratelst;
		}
	}
}
</add after>

<search for>
	my ($template_move, $template_remove, $template_splice, $template_lock, $template_hide, $template_sticky, $template_multidelete, $recycle);
	$recycle = $currentboard eq $binboard ? 1 : 0;
</search for>

<add after>
if ($enable_ratings && ${$uid.$currentboard}{'brate_enable'}) {
	
	$admin_rate = "";
	if ((($iammod && $allow_modrate) || $iamadmin || $iamgmod) && $sessionvalid == 1 && $tviewrate != 0 && $mstate !~ /l/i ) { 
		
		if(!-e ("$RatesDir/$viewnum.rate") && ${$uid.$currentboard}{'apply_arate'}) {
		if(!-e ("$vardir/rateitlist.txt")) {
			fopen(FILE, ">$vardir/rateitlist.txt", 1);
			print FILE "|1|1|1\n";
			fclose(FILE);
		}

		fopen(FILE, "$vardir/rateitlist.txt");
		@ratelist = <FILE>;
		$listnum = @ratelist;
		fclose(FILE);

		$namestart = "";
		$namestart .= qq($msubthread|$date|$mstate);
		$ratelink = qq~$scripturl?num=$viewnum~;

		fopen( FILE, ">$RatesDir/$viewnum.rate", 1);
		print FILE "$currentboard|$boardname\n";
		print FILE "$namestart\n";
		print FILE "\n";
		print FILE "0.00|0\n";
		print FILE "$ratelink\n";
		fclose(FILE);

		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		foreach $currate (@ratelist) {
			chomp $currate;
			print FILE "$currate\n";
		}
		print FILE "$mnum|$username|$currentboard|$mstate\n";
		fclose(FILE);
		}
		
		if(!${$uid.$currentboard}{'apply_arate'}) {
			if(-e ("$RatesDir/$viewnum.rate")) {
				$admin_rate = qq~$menusep<a href="$scripturl?action=raterem;thread=$viewnum">$img{'rem_rating'}</a>~;
			} else {
				$admin_rate = qq~$menusep<a href="$scripturl?action=rateadd;thread=$viewnum;yabbcat=$currentboard;ratecat=$boardname;ratename=$msubthread;ratestatus=$mstate">$img{'add_rating'}</a>~;
			}
		}
	}

	if(-e ("$RatesDir/$viewnum.rate") && $tviewrate != 0){
		require "$sourcedir/RateIT.pl";
		&RatingTopic($mstate);
		
		$topic_topicbrating = "";
		$topic_topicarating = "";
			
		if ($tviewrate == 1 ) {
			$topic_topicbrating .= $yymainrating;
			$display_template =~ s/<yabb topicbrating>/$topic_topicbrating/g;
		}
		if ($tviewrate == 2 ) {
			$topic_topicarating .= $yymainrating;
			$display_template =~ s/<yabb topicarating>/$topic_topicarating/g;
		}
	}		
}
</add after>

<search for>
	$adminhandellist =~ s/<yabb multidelete>/$template_multidelete/g;
</search for>

<add after>
	$adminhandellist =~ s/<yabb ratingt>/$admin_rate/g;
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
if ($action eq 'detailedversion') { return 1; }
</search for>

<add after>
if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; LoadLanguage("RateIT"); }
</add after>

<search for>
	&BoardTotals("load", $currentboard);
</search for>

<add after>
if ($enable_ratings) {
	my ($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst);
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @boardratecontrols = <RATECONTROL>;
	fclose(RATECONTROL);
	foreach my $boardrateline (@boardratecontrols) {
		$boardrateline =~ s/[\r\n]//g;
		chomp $boardrateline;
		($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst) = split(/\|/, $boardrateline);
		if ($currentboard eq $cntrateboard) {
			${$uid.$cntrateboard}{'brate_enable'} = $cntbrateenable;
			${$uid.$cntrateboard}{'apply_arate'} = $cntautoapplyrate;
			${$uid.$cntrateboard}{'view_arate'} = $cntviewrateindex;
			${$uid.$cntrateboard}{'view_ratestar'} = $cntratestar;
			${$uid.$cntrateboard}{'view_rategraph'} = $cntrategraph;
			${$uid.$cntrateboard}{'view_bratelst'} = $cntboardratelst;
		}
	}
}
</add after>

<search for>
		$adminheader =~ s/<yabb admin>/$adminlink/g;
	}
</search for>

<add after>
		$colspan2 = 7;
	if(${$uid.$currentboard}{'brate_enable'} && ${$uid.$currentboard}{'view_arate'} == 1 && $enable_ratings && $tviewrate) {
		$colspan2 = 8;
		$colspan = ++$colspan;
		$rating_title .= qq~<td class="titlebg" align="center">$mbcrate{'04'}</td>~;
		$messageindex_template =~ s/<yabb rating title>/$rating_title/g;
	}
</add after>

<search for>
			$temp_attachment = qq~<img src="$imagesdir/paperclip.gif" alt="$attalttext" />~;
		}
</search for>

<add after>
if(!-e ("$RatesDir/$mnum.rate") && ${$uid.$currentboard}{'brate_enable'} && ${$uid.$currentboard}{'apply_arate'} == 1 && $enable_ratings && $mstate !~ /a/i  && $mstate !~ /l/i && $tviewrate) {
		if(!-e ("$vardir/rateitlist.txt")) {
			fopen(FILE, ">$vardir/rateitlist.txt", 1);
			print FILE "|1|1|1\n";
			fclose(FILE);
		}

		fopen(FILE, "$vardir/rateitlist.txt");
		@ratelist = <FILE>;
		$listnum = @ratelist;
		fclose(FILE);

		$namestart = "";
		$namestart .= qq($msub|$date|$mstate);
		$ratelink = qq~$scripturl?num=$mnum~;

		fopen( FILE, ">$RatesDir/$mnum.rate", 1);
		print FILE "$currentboard|$boardname\n";
		print FILE "$namestart\n";
		print FILE "\n";
		print FILE "0.00|0\n";
		print FILE "$ratelink\n";
		fclose(FILE);

		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		foreach $currate (@ratelist) {
			chomp $currate;
			print FILE "$currate\n";
		}
		print FILE "$mnum|$username|$currentboard|$mstate\n";
		fclose(FILE);
}
	
if (${$uid.$currentboard}{'brate_enable'} && ${$uid.$currentboard}{'view_arate'} == 1 && $enable_ratings && $tviewrate) {
		@rateinfo = ();
		fopen(RATEFILEREAD,"$RatesDir/$mnum.rate");
		@rateinfo = <RATEFILEREAD>;
		$lines = @rateinfo;
		fclose(RATEFILEREAD);
		chomp @rateinfo;
		$raters = $lines - 5;
		($rating, $clicks) = split(/\|/,$rateinfo[3]);
		if($rating == 0) { $rating = "0.00" }
		$barrate = $rating * 10;
		$ratebar = "";
		$ratebar1 = "";
		$ratebar2 = "";
		$barchart = int($barrate);

		$ratebar2 .= qq~<td class="windowbg" align="right">~;
	
if ($mstate !~ /a/i && -e ("$RatesDir/$mnum.rate")) {
		
	if(${$uid.$currentboard}{'view_rategraph'} == 1) {

		if(${$uid.$currentboard}{'view_ratestar'} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st00.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st01.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st02.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st03.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st04.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			else { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st05.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
		} else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {
				$ratebar = "$ratebar";
			} else {
				$ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle" />~;
			}
			if ($barchart > 99) {
				$ratebar1 = "$ratebar1";
			} else {
				$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle" />~;
			}
			$ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum">$ratebar$ratebar1</a></font></div>~;
		}

	} else {

		if(${$uid.$currentboard}{'view_ratestar'} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st00.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st01.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st02.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st03.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st04.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			else { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st05.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
		} else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {
				$ratebar = "$ratebar";
			} else {
				$ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle" />~;
			}
			if ($barchart > 99) {
				$ratebar1 = "$ratebar1";
			} else {
				$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle" />~;
			}
				$ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum">$ratebar$ratebar1</a><br />$ratetxt{'05'} $raters</span></div>~;
		}

	}
	
} else {
		$ratebar2 .= qq~&nbsp;~;
}
		$ratebar2 .= qq~</td>~;
}
</add after>

<search for>
		$tempbar =~ s/<yabb lastposter>/$lastpostername/g;
		$tempbar =~ s/<yabb replies>/$mreplies/g;
</search for>

<add after>
		$tempbar =~ s/<yabb rating column>/$ratebar2/g;
</add after>

<search for>
	my $multiview = 0;
	my $tmptempfooter;
</search for>

<add before>
	$colspanfooter = --$colspan;
	$subfooterbar =~ s/<yabb colspan2>/$colspanfooter/g;
</add before>

<search for>
	# Put a "no messages" message if no threads exisit - just a  bit more friendly...
	if (!$tmptempbar) {

		# check howmany col's must be spanned
		if ((($iamadmin && $adminview >= 1) || ($iamgmod && $gmodview >= 1) || ($iammod && $modview >= 1)) && $sessionvalid == 1) {
			$colspan = 8;
		} else {
			$colspan = 7;
		}
</search for>

<replace>
	# Put a "no messages" message if no threads exisit - just a  bit more friendly...
	if (!$tmptempbar) {
</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
		require "$sourcedir/Notify.pl";
		&ManageThreadNotify("delete", $thread, $username);
	}
</search for>

<add after>
		if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; }
		if(-e ("$RatesDir/$threadid.rate")) {
			fopen(FILE, "$RatesDir/$threadid.rate");
			@currate = <FILE>;
			$ratenum = @currate;
			fclose(FILE);
			chomp @currate;
			($nwratingboard, $dummy, $dummy) = split(/\|/, $board{"$currentboard"});
			($ratetradename, $rateid, $rtstate) = split(/\|/,$currate[1]);
			$ratetradename = $subject;
			fopen(FILE, ">$RatesDir/$threadid.rate", 1);
			print FILE "$currentboard|$nwratingboard\n";
			print FILE "$ratetradename|$rateid|$rtstate\n";
			for ($i=2; $i<$ratenum; $i++) {
			chomp $currate;
			print FILE "$currate[$i]\n";
			}
			fclose(FILE);
		}
</add after>

<edit file>
Sources/MoveTopic.pl
</edit file>

<search for>
		seek AMP, 0, 0;
		print AMP @buffer;
		fclose(AMP);
	}
</search for>

<add after>
	if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; }
	# now fix Rating
	if(-e ("$RatesDir/$thread.rate")) {
	fopen(FILE, "$RatesDir/$thread.rate");
	@ratesettings=<FILE>;
	$ratenum = @ratesettings;
	fclose(FILE);
	chomp @ratesettings;
			($newratingboard, $dummy, $dummy) = split(/\|/, $board{$toboard});
			fopen( FILE, ">$RatesDir/$thread.rate", 1);
			print FILE "$toboard|$newratingboard\n";
			for($i=1; $i<$ratenum; $i++) {
				chomp @ratesettings;
				print FILE "$ratesettings[$i]\n";
			}
			fclose(FILE);
	}
</add after>

<edit file>
Sources/SetStatus.pl
</edit file>

<search for>
		fclose(BOARDFILE);
	} else {
</search for>

<replace>
		fclose(BOARDFILE);
		
		fopen(RATEFILE, "$vardir/rateitlist.txt");
		@ratelist = <RATEFILE>;
		fclose(RATEFILE);

		fopen(RATEFILE, ">$vardir/rateitlist.txt", 1);
		foreach $currate (@ratelist) {
			chomp $currate;
			($thiscurrate, $thiscurusr, $thiscurbrd, $thiscurstate) = split(/\|/, $currate);
			if($thiscurrate ne $threadid) { 
				print RATEFILE "$currate\n"; 
			} else { 
				print RATEFILE "$thiscurrate|$thiscurusr|$thiscurbrd|$status\n"; 
			}
		}
		fclose(RATEFILE);
		
	} else {
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
		$menusep<form name="return_to" action="$scripturl?action=revalidatesession" method="post"><input type="hidden" name="urlref" value="" /></form><a href="javascript:returnto(document.location.href);">$img{'sessreval'}</a>
		~;
</search for>

<add after>
	if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; }
</add after>

<search for>
		$yymenu .= qq~
			<script language="JavaScript1.2" type="text/javascript">
			<!--
			function returnto(GOTO) {
				GOTO = GOTO.replace(/=/g, "%3d");
				GOTO = GOTO.replace('$scripturl?', '');
				document.return_to.urlref.value = GOTO;
				document.return_to.submit();
			}
			-->
			</script>
		$menusep<form name="return_to" action="$scripturl?action=login" method="post"><input type="hidden" name="urlref" value="" /></form><a href="javascript:returnto(document.location.href);">$img{'login'}</a>
			~;
</search for>

<add before>
		if ($enable_ratings && $en_ratingsmenu == 2) { $yymenu .= qq~$menusep<a href="$scripturl?action=rateshow;editmode=new;start=0">$img{'rating'}</a>~; }
</add before>

<search for>
		$yymenu .= qq~$menusep<a href="$scripturl?action=viewprofile;username=$username">$img{'profile'}</a>~;
</search for>

<add after>
		if ($enable_ratings && $en_ratingsmenu) { $yymenu .= qq~$menusep<a href="$scripturl?action=rateshow;editmode=new;start=0">$img{'rating'}</a>~; }
</add after>

<search for>
	if ($removethread) {
</search for>

<add after>
		if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; }
		if(-e ("$RatesDir/$removethread.rate")) {
			fopen(FILE, "$vardir/rateitlist.txt");
			@ratelist = <FILE>;
			fclose(FILE);
			fopen(FILE, ">$vardir/rateitlist.txt", 1);
			foreach $currate (@ratelist) {
				chomp $currate;
				($thiscurrate, undef, undef, undef) = split(/\|/, $currate);
				if($thiscurrate ne $removethread) { print FILE "$currate\n"; }
			}
			fclose(FILE);
			unlink("$RatesDir/$removethread.rate");
		}
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'recent',"Recent.pl&RecentPosts",
</search for>

<add before>
'ratedelcomment',"RateIT.pl&DelComment",
'rateshow',"RateIT.pl&Rate",
'rateshow2',"RateIT.pl&ShowRate2",
'ratesett2',"RateIT.pl&Rate2",
'ratesett',"RateIT.pl&Rate3",
'rateclicks',"RateIT.pl&ClickCount",
'ratejump',"RateIT.pl&CatJump",
'rateoverview',"RateIT.pl&ItemOverview",
'ratesettsort',"RateIT.pl&Rate",
'rateshowpg',"RateIT.pl&Rate",
'ratecomment',"RateIT.pl&RateComment",
'ratepagesett',"RateIT.pl&PageSetting",
'ratepglink',"RateIT.pl&RatingLink",
'rateadd',"RateIT.pl&AdminAddRate",
'raterem',"RateIT.pl&AdminRemRate",
</add before>

<edit file>
Sources/System.pl
</edit file>

<search for>
			my @tags = qw(board threadcount messagecount lastposttime lastposter lastpostid lastreply lastsubject lasticon);
</search for>

<add after>
			push (@tags,"brate_enable");
			push (@tags,"apply_arate");
			push (@tags,"view_arate");
			push (@tags,"view_ratestar");
			push (@tags,"view_rategraph");
			push (@tags,"view_bratelst");
</add after>

<search for>
			my @tags = qw(board threadcount messagecount lastposttime lastposter lastpostid lastreply lastsubject lasticon);
</search for>

<add after>
			push (@tags,"brate_enable");
			push (@tags,"apply_arate");
			push (@tags,"view_arate");
			push (@tags,"view_ratestar");
			push (@tags,"view_rategraph");
			push (@tags,"view_bratelst");
</add after>

<edit file>
Variables/Menu0.def
</edit file>

<search for>
'admin_move' => "<img src=\"$imagesdir/admin_move.$imgext\" alt=\"$img_txt{'132'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'132'}</span>",
</search for>

<add after>
'rating' => "<img src=\"$modimgurl/RateIT/rate.$imgext\" alt=\"$img_txt{'02d'}\" border=\"0\" /> <span class=\"imgmenu\">$img_txt{'02d'}</span>",
'add_rating' => "<img src=\"$modimgurl/RateIT/rate.$imgext\" alt=\"$img_txt{'03d'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'03d'}</span>",
'rem_rating' => "<img src=\"$modimgurl/RateIT/remrate.$imgext\" alt=\"$img_txt{'04d'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'04d'}</span>",
</add after>

<edit file>
Variables/Menu1.def
</edit file>

<search for>
'admin_move' => "<span class=\"imgwindowbg\">$img_txt{'132'}</span>",
</search for>

<add after>
'rating' => "<span class=\"imgmenu\">$img_txt{'02d'}</span>",
'add_rating' => "<span class=\"imgwindowbg\">$img_txt{'03d'}</span>",
'rem_rating' => "<span class=\"imgwindowbg\">$img_txt{'04d'}</span>",
</add after>

<edit file>
Variables/Menu2.def
</edit file>

<search for>
'remfav' => "<img src=\"$html_root/Buttons/$language/remfav.$imgext\" alt=\"$img_txt{'626'}\" border=\"0\" />",
</search for>

<add after>
'rating' => "<img src=\"$html_root/Buttons/$language/rate.$imgext\" alt=\"$img_txt{'02d'}\" border=\"0\" />",
'add_rating' => "<img src=\"$html_root/Buttons/$language/addrate.$imgext\" alt=\"$img_txt{'03d'}\" border=\"0\" />",
'rem_rating' => "<img src=\"$html_root/Buttons/$language/remrate.$imgext\" alt=\"$img_txt{'04d'}\" border=\"0\" />",
</add after>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$rating = "ratings|RateIT Mod|RateIT Mod|";
	push (@boardmod_mods, "$rating");
</add before>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
	<yabb move><yabb remove><yabb splice><yabb lock><yabb hide><yabb sticky><yabb multidelete>
</search for>

<replace>
	<yabb move><yabb remove><yabb splice><yabb lock><yabb hide><yabb sticky><yabb multidelete><yabb ratingt>
</replace>

<search for>
<div class="displaycontainer">
<div style="clear: both;"></div>
</search for>

<add after>
<yabb topicarating>
</add after>

<search for>
<!-- Threads Title Bar start -->

<div class="displaycontainer">
</search for>

<replace>
<!-- Threads Title Bar start -->
<yabb topicbrating>
<div class="displaycontainer">
</replace>

<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
<yabb admin column>
</tr>
~;
</search for>

<add before>
<yabb rating column>
</add before>

<search for>
	</td>
	<yabb admin column>
</tr>
</search for>

<replace>
	</td>
	<yabb rating title>
	<yabb admin column>
</tr>
</replace>

<search for>
$subfooterbar = qq~
<tr>
<td class="titlebg" valign="middle" align="right" colspan="7">
</search for>

<replace>
$subfooterbar = qq~
<tr>
<td class="titlebg" valign="middle" align="right" colspan="<yabb colspan2>">
</replace>