#!/usr/bin/perl

###############################
#	Ratetoplist 4.5		#
#	for YaBB SP 1.3		#
#	by Carsten			#
###############################

use CGI::Carp qw(fatalsToBrowser);
require "Paths.pl";
require "$vardir/RatingConf.txt";
require "$sourcedir/Subs.pl";
&LoadLanguage("RateIT");
use CGI qw/:standard/;

####### Table Settings ########
$tablebordercolor = "#62686F";	# set tableborder color
$tabletitlebgcolor = "#F2F6F9";	# set title background color

######## Font Settings ########
$titlefontsize = 2;			# set text size for title (default 2)
$textfontsize = 1;			# set text size for description (default 1)
$titlefontcolor = "#000000";		# set text color for title (default black)
$textfontcolor = "#000000";		# set text color for description (default black)
$fontface = "Arial";			# set text font (default Arial)

###############################

my($topdir);

$topdir = qq~$boardurl/Ratetoplist.pl~;

foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
	$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	($cookie,$value) = split(/=/);
	$yyCookies{$cookie} = $value;
}
if( $yyCookies{$cookiepassword} ) {
	$password = $yyCookies{$cookiepassword};
	$username = $yyCookies{$cookieusername} || 'Guest';
} else {
	$password = '';
	$username = 'Guest';
}

if($action eq "seltoprate") { &TopRate }
elsif($action eq "seltoprate2") { &TopRate2 }

sub TopRate {

my($rate);

getinfo(%theinfo);
$rate = $theinfo{'rateid'};

print "Content-type: text/html\n\n";

print <<"EOT";
<html>
<head>
</head>
<body>
EOT

	@rateinfo = ();
	open(RATEFILEREAD,"$RatesDir/$rate.rate");
	&lock(RATEFILEREAD);
	@rateinfo = <RATEFILEREAD>;
	$lines = @rateinfo;
	&unlock(RATEFILEREAD);
	close(RATEFILEREAD);
	chomp @rateinfo;
	($thisname, $dummy) = split(/\|/,$rateinfo[1]);
	$thisuser = $username;
	if($thisuser eq "Guest") { $thisuser = $user_ip }
	$totalrate = 0;
	$raters = $lines - 5;
	if($raters > 0) {
		for($i=5; $i < $lines; $i++) {
			($thisrater, $thisrate) = split(/\|/,$rateinfo[$i]);
			if($thisuser eq $thisrater) { 
				$intrate = int($thisrate);
				$check[$intrate] = "selected";
			}
			$totalrate = $totalrate + $thisrate;
		}
		$therate = sprintf ("%.2f", ($totalrate/$raters));
	}
	else { $therate = "0.00" }

	($rating, $clicks) = split(/\|/,$rateinfo[3]);
	$link = $rateinfo[4];
	$barrate = $rating * 10;
	$ratebar = "";
	$ratebar1 = "";
	$ratebar2 = "";
	$barchart = int($barrate);
	$barchart1 = 100 - $barchart;
	if ($barchart < 1) {$ratebar = "$ratebar";}
	else {
		$ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0">~;
	}
	if ($barchart > 99) {$ratebar1 = "$ratebar1";}
	else {
		$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0">~;
	}
	$ratebar2 = qq~$ratebar$ratebar1~;

print <<"EOT";
<table width="330" height="30" align="center" border="0" cellpadding="0" cellspacing="0" bgcolor="$tablebordercolor">
<tr>
<td width="100%" height="100%">
<table width="100%" height="100%" border="0" cellpadding="0" cellspacing="1">
<tr>
	<td align="right" height="100%">
		<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="right" bgcolor="$tabletitlebgcolor">
		<tr>
		<td align="right" height="100%" valign="middle">
			<font face="$fontface" size="$titlefontsize" color="$titlefontcolor">$ratetxt{'03'}:</font>
		</td>
			<form method="post" action="$topdir?action=seltoprate2" name="$rate">
			<input type="hidden" name="filename" value="$rate">
			<input type="hidden" name="username" value="$username">
		<td align="left" height="100%" valign="middle">
			<select name="rating" style="font-size: 9" onChange="submit(); return true">
				<option value="0" $check[0]>---</option>
				<option value="10" $check[10]>10 $ratetxt{'48'}</option>
				<option value="9" $check[9]>9</option>
				<option value="8" $check[8]>8</option>
				<option value="7" $check[7]>7</option>
				<option value="6" $check[6]>6</option>
				<option value="5" $check[5]>5</option>
				<option value="4" $check[4]>4</option>
				<option value="3" $check[3]>3</option>
				<option value="2" $check[2]>2</option>
				<option value="1" $check[1]>1</option>
			</select>
		</td>
			</form>
		</tr>
		</table>
	</td>
	<td align="right" height="100%">
	<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="4" align="right" bgcolor="$tabletitlebgcolor">
		<tr>
			<td align="right" valign="middle">
				<font face="$fontface" size="$titlefontsize" color="$titlefontcolor">$therate</font>
			</td>
			<td align="left" valign="middle">
				<a href="$boardurl/YaBB.cgi?action=ratepglink;editmode=new;itemlink=$rate" target="_blank">$ratebar2</a>
			</td>
			<td align="left" valign="middle">
				<font face="$fontface" size="1" color="$titlefontcolor"><nobr><i>$ratetxt{'05'}: $raters</i></nobr></font>
			</td>
		</tr>
		</table>
	</td>
</tr>
</table>

</td>
</tr>
</table>
</body>
</html>
EOT
}


sub TopRate2 {

my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$rating{$key} = $value;
}
$rating{'username'} = $username;
$thdate = $date;
$thisrate = $rating{'rating'};
$thisrater = $rating{'username'};
if($thisrater eq "Guest") { $thisrater = $user_ip }
$thrater = $rating{'username'};

fopen(FILE, "$RatesDir/$rating{'filename'}.rate");
@ratesettings=<FILE>;
$ratenum = @ratesettings;
fclose(FILE);
chomp @ratesettings;

($rates, $rateclicks) = split(/\|/,$ratesettings[3]);
$raters = $ratenum - 5;
$newflag = 1;

if($thisrate == 0) {
	$comminfo = "norate";
	$newraters = $raters - 1;
	for($i=5;$i<$ratenum;$i++) {
		($therater, $oldrate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($thisrater eq $therater) { $thisoldrate = $oldrate }
	}
	if($newraters < 1) {
		$newrate = 0.00;
	}
	else {
		$newrate = sprintf ("%.2f", ((($rates*$raters) - $thisoldrate)/$newraters));
	}
	$ratesclick .= qq($newrate|$rateclicks);

	fopen( FILE, ">$RatesDir/$rating{'filename'}.rate", 1);
	print FILE "$ratesettings[0]\n";
	print FILE "$ratesettings[1]\n";
	print FILE "$ratesettings[2]\n";
	print FILE "$ratesclick\n";
	print FILE "$ratesettings[4]\n";
	for($i=5;$i<$ratenum;$i++) {
		($therater, $oldrate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($therater ne $thisrater) { 
			print FILE "$ratesettings[$i]\n";
		}
	}
	fclose(FILE);
}

else {
	$comminfo = $rating{'filename'};
	for($i=5;$i<$ratenum;$i++) {
		($oldrater, $oldrate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($thisrater eq $oldrater) {
			$ratesettings[$i] = "";
			$ratesettings[$i] .= qq($oldrater|$thisrate|$trater|$tcomment|$tdate);
			$newrate = sprintf ("%.2f", (((($rates*$raters) - $oldrate) + $thisrate)/$raters));
			$newflag = 0;
		}
	}
	if($newflag) {
		$newraters = $raters + 1;
		$newrate = sprintf ("%.2f", ((($rates*$raters) + $thisrate)/$newraters));
	}

	$ratesclick .= qq($newrate|$rateclicks);
	fopen( FILE, ">$RatesDir/$rating{'filename'}.rate", 1);
	print FILE "$ratesettings[0]\n";
	print FILE "$ratesettings[1]\n";
	print FILE "$ratesettings[2]\n";
	print FILE "$ratesclick\n";
	print FILE "$ratesettings[4]\n";
	if($newflag) {
		print FILE "$thisrater|$thisrate|$thrater|$thcomment|$thdate\n";
		for($i=5;$i<$ratenum;$i++) { print FILE "$ratesettings[$i]\n"; }
	}
	else {
		for($i=5;$i<$ratenum;$i++) { print FILE "$ratesettings[$i]\n"; }
	}
	fclose(FILE);
}

$yySetLocation = qq~$topdir?action=seltoprate;rateid=$rating{'filename'}~;
&redirectexit;

}


sub getinfo {

my ($tmpst);

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	$tmpst = $ENV{'QUERY_STRING'};
}
else {
	read(STDIN, $tmpst, $ENV{'CONTENT_LENGTH'});
}

foreach (split(/;/, $tmpst)) {
	my($key, $value) = split(/=/, $_);
	$value =~ tr/+/ /;
	$value =~ s/%(..)/pack('c', hex($1))/eg;
	$theinfo{$key} = $value;
}

}

sub lock {
	my $lock_file = $_[0];
	my $flag = 1;
	my $count = 0;
	if($use_flock==1) {
		flock($lock_file, $LOCK_EX);
	} elsif ($use_flock==2) {

		while($flag and $count < 15) {
			$flag = check_flock($lock_file);
			$count++;
		}

		unlink($lock_file) if ($count == 15);
		open(LOCK_FILE, ">$lock_file");
	}
}

sub unlock {
	my $lock_file = $_[0];

	if($use_flock==1) {
		flock($lock_file, $LOCK_UN);
	} elsif ($use_flock==2) {
		close(LOCK_FILE);
		unlink($lock_file) if (-e $lock_file);
	}
}


exit;

1;
